{% extends 'base.njk' %}{% block title %}BCHN Technical Bulletin 2020-05-04{% endblock %}{% block description %}{% endblock %}{% block body %}
<section class="bg-dark">
    <div class="container">
        <div class="row pb-3">
            <div class="col my-5 py-5 text-center">
                <h1 class="text-white">BCHN Technical Bulletin 2020-05-04</h1> 
            </div>
        </div>
    </div>
</section>
<section class="bg-light">
    <div class="container py-6">
        <div class="row justify-content-center">
            <article class="col-md-10 col-lg-8">
                <div class="d-flex align-items-center pb-5">
                    <img src="/static/img/logomark.svg" alt="Logo" class="mr-3 w-auto" height="40">
                    <div>
                        <div>by <strong>Calin Culianu</strong>
                        </div>
                        <div class="text-small text-muted">4 May 2020</div>
                    </div>
                </div>
                <div class="content">
                    <p>

                    </p>
                    <h3 id="getblocktemplate-light">GetBlockTemplate Light</h3>
                    <p>In order to provide the most efficient mining RPCs, we have implemented the <code class="language-javascript">getblocktemplatelight</code> RPC which is popular amongst various mining pools such as BTC.COM and others.</p>
                    <p>The two new RPC's are: <code class="language-javascript">getblocktemplatelight</code> and <code class="language-javascript">submitblocklight</code>. These RPCs reduce the round-trip time for mining software when retrieving new block templates.
                        Transaction data is never sent between mining software and <code class="language-javascript">bitcoind</code>. Instead, <code class="language-javascript">job_id</code>'s are returned and <code class="language-javascript">bitcoind</code> later
                        reconstructs the full block based on this <code class="language-javascript">job_id</code> and the solved header + coinbase submitted by the miner, leading to more efficient mining.</p>
                    <p>A full description and specification for this facility can be found here: <a href="https://gitlab.com/bitcoin-cash-node/bitcoin-cash-node/-/blob/master/doc/getblocktemplatelight.md"><a href="https://gitlab.com/bitcoin-cash-node/bitcoin-cash-node/-/blob/master/doc/getblocktemplatelight.md">https://gitlab.com/bitcoin-cash-node/bitcoin-cash-node/-/blob/master/doc/getblocktemplatelight.md</a></a>
                    </p>
                    <p>Below are some benchmarks:</p>
                    <p><strong>Bitcoin Cash Node v0.21.2 (gitlab,</strong>  <a href="https://gitlab.com/bitcoin-cash-node/bitcoin-cash-node/-/merge_requests/281"><strong>Merge Request 281</strong></a><strong>)</strong>
                    </p>
                    <p><code class="language-javascript">getblocktemplatelight</code>, 6000 tx mempool (1271847 bytes)</p>
                    <ul>
                        <li>
                            <p>New template generation</p>
                            <ul>
                                <li>call time, avg.: <strong>62.025</strong>  <em>milliseconds</em>
                                </li>
                            </ul>
                        </li>
                        <li>
                            <p>Cached template (returned if you call again within 5 seconds and no new tx's)</p>
                            <ul>
                                <li>call time, avg.: <strong>0.917</strong>  <em>milliseconds</em>
                                </li>
                            </ul>
                        </li>
                    </ul>
                    <p><strong>Bitcoin ABC v0.21.6 (github master) + BTC.COM gbtl patch from</strong>  <a href="https://github.com/btccom/bitcoin-abc-1"><a href="https://github.com/btccom/bitcoin-abc-1">https://github.com/btccom/bitcoin-abc-1</a></a>
                    </p>
                    <p><code class="language-javascript">getblocktemplatelight</code>, 6000 tx mempool (1271847 bytes)</p>
                    <ul>
                        <li>
                            <p>New template generation</p>
                            <ul>
                                <li>call time, avg.: <strong>64.200</strong>  <em>milliseconds</em>
                                </li>
                            </ul>
                        </li>
                        <li>
                            <p>Cached template (returned if you call again within 5 seconds and no new tx's)</p>
                            <ul>
                                <li>call time, avg.: <strong>4.909</strong>  <em>milliseconds</em>
                                </li>
                            </ul>
                        </li>
                    </ul>
                    <p><strong>Winner:</strong>  <strong><em>BCHN</em></strong>
                    </p>
                    <p>For the first call to light GBT, ABC and BCHN are comparable. This is because the call is dominated by generating the new template by scanning the mempool. Subsequent calls (which are the common case) show a 4x speed improvement in <strong>BCHN</strong> over
                        ABC, because BCHN uses better caching.</p>
                    <hr>
                    <h3 id="getblocktemplate-regular-improvements">GetBlockTemplate (regular) Improvements</h3>
                    <p>Bitcoin Cash Node has made some improvements to the regular mining RPC calls. The <code class="language-javascript">getblocktemplate</code> call has been made up to <strong>70% faster</strong> than the current ABC implementation. We have
                        optimized the JSON RPC code to be much more efficient.</p>
                    <p>Below are some benchmarks:</p>
                    <p><strong>Bitcoin Cash Node v0.21.2 (git master)</strong>
                    </p>
                    <p><code class="language-javascript">getblocktemplate</code>, 6000 tx mempool (1271847 bytes)</p>
                    <ul>
                        <li>
                            <p>New template generation</p>
                            <ul>
                                <li>call time, avg.: <strong>164.023</strong>  <em>milliseconds</em>
                                </li>
                            </ul>
                        </li>
                        <li>
                            <p>Cached template (returned if you call again within 5 seconds and no new tx's)</p>
                            <ul>
                                <li>call time, avg.: <strong>117.277</strong>  <em>milliseconds</em>
                                </li>
                            </ul>
                        </li>
                    </ul>
                    <p><strong>Bitcoin ABC v0.21.6 (git master)</strong>
                    </p>
                    <p><code class="language-javascript">getblocktemplate</code>, 6000 tx mempool (1271847 bytes)</p>
                    <ul>
                        <li>
                            <p>New template generation</p>
                            <ul>
                                <li>call time, avg.: <strong>262.200</strong>  <em>milliseconds</em>
                                </li>
                            </ul>
                        </li>
                        <li>
                            <p>Cached template (returned if you call again within 5 seconds and no new tx's)</p>
                            <ul>
                                <li>call time, avg.: <strong>200.476</strong>  <em>milliseconds</em>
                                </li>
                            </ul>
                        </li>
                    </ul>
                    <p><strong>Winner:</strong>  <strong><em>BCHN</em></strong>
                    </p>
                    <p>Between <strong>60%</strong> - <strong>70%</strong> speed improvement for both calls with BCHN. This is because the verbose <code class="language-javascript">getblocktemplate</code> returns a large JSON object. BCHN has heavily optimized
                        the JSON generation code to reduce overhead.</p>
                    <hr>
                    <h3 id="where-to-get-bchn-gbt-light">Where to get BCHN + GBT Light</h3>
                    <p><strong>v0.21.2 is coming soon!</strong> - This new facility is currently in review but will appear in the upcoming 0.21.2 BCHN release very soon.</p>
                    <p>You may see the review branch here:</p>
                    <ul>
                        <li>Merge request: <a href="https://gitlab.com/bitcoin-cash-node/bitcoin-cash-node/-/merge_requests/281">gitlab.com/bitcoin-cash-node/bitcoin-cash-node/-/merge_requests/281</a>
                        </li>
                    </ul>
                    <p>Or you can download a <em>binary pre-release</em> here:</p>
                    <ul>
                        <li>Binaries: <a href="https://c3-soft.com/downloads/BitcoinCash/bchn/GBTLight/">c3-soft.com/downloads/BitcoinCash/bchn/GBTLight/</a>
                        </li>
                    </ul>
                    <hr>
                    <p>Links:</p>
                    <ul>
                        <li>
                            <p>Instructions on how to perform this benchmark: <a href="https://gist.github.com/cculianu/20309e67ff82caa397b4460ec011ad54">GitHub Gist</a>
                            </p>
                        </li>
                        <li>
                            <p>Repository link of this announcement: <a href="https://gitlab.com/bitcoin-cash-node/announcements/-/blob/master/20200504_gbt_light_announcement.md">GitLab</a>
                            </p>
                        </li>
                    </ul>
                </div>
            </article>
        </div>
    </div>
</section>
{% endblock %}
